<?php        
defined('C5_EXECUTE') or die(_("Access Denied."));

class SkybluesofaSocialWidgetBlockController extends BlockController {
	
	var $pobj;

	protected $btTable = 'btSkybluesofaSocialWidget';
	protected $btInterfaceWidth = "640";
	protected $btInterfaceHeight = "400";
	protected $btWrapperClass = 'ccm-ui';
	protected $db = null;
			
	/** 
	 * Used for localization. If we want to localize the name/description we have to include this
	 */
	public function getBlockTypeDescription() {
		return t("Displays social widgets on your site");
	}
	
	public function getBlockTypeName() {
		return t("Social Widget");
	}		
	
	
	public function __construct($obj = null) {		
		parent::__construct($obj); 
		$this->db = Loader::db();
	}
	
	public function view() {
		$pkg = Loader::package('skybluesofa_social_share');
		echo "<!-- Social Share v".$pkg->getPackageVersion()." by Sky Blue Sofa -->";
		
	}

	function add() {
	}
	
	function edit() {
	}
	
	/*
	 * save block config
	 */ 
	public function save($args) {
		$args['floating_offset'] = empty($args['floating_offset']) ? '0' : $args['floating_offset'];
		parent::save($args);
		$this->saveConnections($this->bID, $args);
	}
	
	function duplicate($newBID) {
		parent::duplicate($newBID);
		$this->duplicateConnections($newBID);
	}
		
	public function getConnections($bID) {
        $po = $this->db->GetArray("SELECT * FROM ".$this->btConnectionsTable." WHERE ordinal IS NOT NULL AND bID = ? ORDER BY ordinal", array($bID));
        $no = $this->db->GetArray("SELECT * FROM ".$this->btConnectionsTable." WHERE ordinal IS NULL AND bID = ? ORDER BY connID", array($bID));
        $res = array_merge($po, $no);
        return $res;
	}
	
	public function saveConnections($bID, $args) {
		if (!isset($args['connection']) || !is_array($args['connection'])) {
			return false;
		}
		$this->deleteConnections($bID);
		$ordinal = 1;
		foreach ($args['connection']['connection'] as $key=>$value) {
	
			if ($key && !empty($args['connection']['network'][$key]) && !empty($args['connection']['connection'][$key])) {
				//if (in_array($args['connection']['network'][$key], $this->getNetworks())) {
					$netconn['bID'] = $bID;
					$netconn['ordinal'] = $ordinal;
					$netconn['network'] = $args['connection']['network'][$key];
					if (($args['connection']['network'][$key]=='email') && (strpos($args['connection']['connection'][$key],'@')!==false)) {
						$args['connection']['connection'][$key] = 'mailto:'.$args['connection']['connection'][$key];
					}
					$netconn['url'] = $args['connection']['connection'][$key];
					$netconn['tooltip'] = $args['connection']['tooltip'][$key];
					$this->addConnection($bID, $netconn);
					$ordinal++;
				//}
			}
		}
	}
	
	function duplicateConnections($newBID) {
		$b=$this->getBlockObject(); 
		$c=$b->getBlockCollectionObject();	 
		 
		$res = $this->db->query("select * from " . $this->btTable . " where bID = ?", array($this->bID));
		$existingBlock = $res->fetchRow();
		
		if(count($existingBlock)>0){ 
			$oldBID=$existingBlock['bID'];
			
			$res = $this->db->GetArray("SELECT * FROM ".$this->btConnectionsTable." WHERE bID=?", array($this->bID));
			$existingConnections = array('connection'=>array());
			$existingConnections['connection']['network'][]=null;
			$existingConnections['connection']['connection'][]=null;
			$existingConnections['connection']['tooltip'][]=null;
			foreach ($res as $key=>$connection) {
				$existingConnections['connection']['network'][]=$connection['network'];
				$existingConnections['connection']['connection'][]=$connection['url'];
				$existingConnections['connection']['tooltip'][] = $connection['tooltip'];
			}
			$this->saveConnections($newBID, $existingConnections);
		} else {
			return 0;
		}
	}
	
	public function addConnection($bID, $newNetConn) {
		if (!is_array($newNetConn)) {
			return false;
		}
		$netconn = array('bID'=>$bID, 'ordinal'=>null, 'network'=>null, 'url'=>null, 'tooltip'=>nul);
		foreach ($netconn as $key=>$value) {
			if (array_key_exists($key, $newNetConn)) {
				$netconn[$key] = $newNetConn[$key];
			}
		}
	
		$res = $this->db->Execute("INSERT INTO ".$this->btConnectionsTable." (bID, ordinal, network, url, tooltip) VALUES (?, ?, ?, ?, ?)", $netconn);
		return $res;
	}
	
	public function deleteConnections($bID) {
        $res = $this->db->Execute("DELETE FROM ".$this->btConnectionsTable." WHERE bID = ?", array($bID));
        return $res;
	}
	
	public function getNetworks() {
		$db = Loader::db();
		$this->networks = $db->GetArray("SELECT * FROM btSkybluesofaSocialNetworks WHERE connect=1 ORDER BY name");
		return $this->networks; 	
	}
}

?>