<?php      
Loader::library('facebookauth/inc/facebook','skybluesofa_social_share');
Loader::model('network_social_post','skybluesofa_social_share');

class FacebookSocialPost extends NetworkSocialPost {
	public $settingsGroupName = 'facebook';
	
	private $appId = ''; //Facebook App ID
	private $appSecret = ''; // Facebook App Secret
	public $permissions = 'publish_stream,manage_pages';  //Required facebook permissions
	
	function __construct() {
		parent::__construct();
		
		$this->appId = $this->settings['app_id']['value'];
		$this->appSecret = $this->settings['app_secret']['value'];
	}
	
	public function isRevoked() {
		if (!$this->appId||!$this->appSecret) {
			$this->removeCredentials();
			$this->saveSetting('use', '0');
			return true;
		}
		try {
			$fb = new Facebook(array(
					'appId'  => $this->appId,
					'secret' => $this->appSecret
			));
			$fb->setAccessToken($this->settings['oauth_token']['value']);
			if (!is_a($fb, "Facebook")) {
				$this->removeCredentials();
				$this->saveSetting('use', '0');
				return true;
			}
			
			try {
				$check = $fb->api("/me");
			} catch (FacebookApiException $e) {
				$this->removeCredentials();
				$this->saveSetting('use', '0');
				return true;
			}
			
		} catch(FacebookApiException $e) {
			$this->removeCredentials();
			$this->saveSetting('use', '0');
			return true;
		}
		return false;
	}
	
	public function getTimeline() {
		if ($this->settings['post_to_page']['value'] && $this->settings['post_to_page_name']['value']) {
			return array('id'=>$this->settings['post_to_page']['value'], 'name'=>$this->settings['post_to_page_name']['value']);
		}
		return false;
	}
	
	public function getUserTimelines() {
		$this->getUser();
		if ($this->user) {
			try {
				$user_profile = $this->instance->api('/me');
				//Get user pages details using Facebook Query Language (FQL)
				$fql_query = 'SELECT page_id, name, page_url FROM page WHERE page_id IN (SELECT page_id FROM page_admin WHERE uid='.$this->user.')';
				$postResults = $this->instance->api(array( 'method' => 'fql.query', 'query' => $fql_query ));
			} catch (FacebookApiException $e) {
				$postResults = false;
			}
			return $postResults;
		}
		return false;
	}
	
	public function getTimelineById($id) {
		$this->getFacebook();
		try {
			$fql_query = 'SELECT page_id, name, page_url FROM page WHERE page_id='.$id;
			$postResults = $this->instance->api(array( 'method' => 'fql.query', 'query' => $fql_query ));
			if (!count($postResults)) {
				$user_profile = $this->instance->api('/me');
				if ($user_profile['id']==$id) {
					return $user_profile['name']."'s Timeline";
				}
			}
			if ($postResults[0]) {
				$postResults = $postResults[0];
			}
		} catch (FacebookApiException $e) {
			$postResults = false;
		}
		return isset($postResults['name']) ? $postResults['name'] : false;
	}
	
	public function getFacebook() {
		if ($this->instance) {
			return $this->instance;
		}
		Loader::library('facebookauth/inc/facebook','skybluesofa_social_share');
		$secret = $this->appSecret;
		if ($this->settings['oauth_token']['value']) {
			//$secret = $this->settings['oauth_token']['value'];
		}
		$this->instance = new Facebook(array(
			'appId'  => $this->appId,
			'secret' => $secret
		));
		$this->instance->setAccessToken($this->settings['oauth_token']['value']);
		if (!is_a($this->instance, "Facebook")) {
			$this->updateCredentials(false);
			$this->instance = false;
		}
		return $this->instance;
	}
	
	public function getUser() {
		if (!$this->instance) {
			$this->getFacebook();
		}
		$this->user = $this->instance->getUser();
		return $this->user;
	}
	
	public function getUserName() {
		if (!$this->user) {
			$this->getUser();
		}
		$fql = 'SELECT name from user where uid = ' . $this->user;
		$ret_obj = $this->instance->api(array(
				'method' => 'fql.query',
				'query' => $fql,
		));
		return $ret_obj[0]['name'];
	}
	
	public function getUserPages() {
		if (!$this->user) {
			$this->getUser;
		}
		try {
			$user_profile = $this->instance->api('/me');
			//Get user pages details using Facebook Query Language (FQL)
			$fql_query = 'SELECT page_id, name, page_url FROM page WHERE page_id IN (SELECT page_id FROM page_admin WHERE uid='.$this->user.')';
			$this->pagesToPost = $this->instance->api(array( 'method' => 'fql.query', 'query' => $fql_query ));
			return $this->pagesToPost; 
		} catch (FacebookApiException $e) {
			echo $e->getMessage();
			$this->user = null;
			return false;
		}
	}

	public function getAuthorizeURL() {
		$this->getFacebook();
		return $this->instance->getLoginUrl(array('redirect_uri'=>BASE_URL.DIR_REL.'/index.php/dashboard/skybluesofa/social_post/fb','scope'=>$this->permissions));
	}		
	
	public function saveCredentials() {
		// Facebook connection
		$instance = $this->getFacebook();
		$instance->setExtendedAccessToken();
		$oauth_token = $instance->getExtendedAccessToken();
		if ($oauth_token) {
			$this->updateCredentials($oauth_token);
			$returnValue = true;
		} else {
			$returnValue = false;
		}
		return $returnValue;		
	}
	
	public function updateCredentials($oauth_token) {
		$this->saveSetting('oauth_token', $oauth_token);
		if ($oauth_token) {
			$connected = 1;
			$this->saveSetting('use', '1');
		} else {
			$connected = 0;
			$this->saveSetting('use', '0');
			$this->saveSetting('oauth_token', null);
		}
		$this->saveSetting('connected', $connected);
		$this->getSettings();
	}
	
	public function removeCredentials() {
		$this->updateCredentials(null);
		$this->saveSetting('use', '0');
		$this->saveSetting('post_to_page','');
		$this->saveSetting('post_to_page_name','');
		$this->getSettingsFromDB();
		$this->getSettings();
	}
	
	protected function generatePostContents() {
		$message = $this->settings['prefix']['value'];
		if ($this->hashTags) {
			$message = $message.' '.$this->hashTags;
		}
		$postBody = array(
			'message' => $message,
			'name' => $this->pageName,
			//'caption' => $caption,
			'link' => $this->pageUrl,
			'description' => $this->pageDescription,
			'actions' => array(
					array(
							'name' => SITE,
							'link' => BASE_URL
					)
			)
		);
		if ($this->pageThumbnail) {
			$postBody['picture'] = $this->pageThumbnail;
		}
		return $postBody;
	}
	
	protected function postToNetwork($postContents) {
		$this->getFacebook();
		$success = false;
		if(is_array($this->settings) && $this->settings['use']['value']) {
			if ($this->settings['post_to_page']['value']) {
				$post_url = '/'.$this->settings['post_to_page']['value'].'/feed';
				try {
					$postResult = $this->instance->api($post_url, 'post', $postContents );
					$success = true;
				} catch (FacebookApiException $e) {
					print_r($e);
					$this->removeCredentials(false);
					$success = false;
				}
			}
		}
		return $success;
	}
}
?>