<?php      
Loader::library('linkedinoauth/linkedinoauth','skybluesofa_social_share');
Loader::model('network_social_post','skybluesofa_social_share');

class LinkedInSocialPost extends NetworkSocialPost {
	public $settingsGroupName = 'linkedin';
	
	private $requestTokenUrl='https://api.linkedin.com/oauth/request_token';
	private $accessTokenUrl='https://api.linkedin.com/oauth/access_token';
	private $authorizeUrl='https://api.linkedin.com/oauth/authorize';
	private $verifyUrl='https://api.linkedin.com/1.1/account/verify_credentials.json';
	
	function __construct() {
		parent::__construct();
		
		$this->api_key = $this->settings['api_key']['value'];
		$this->api_secret = $this->settings['api_secret']['value'];
		$this->oauth_token = $this->settings['oauth_token']['value'];
		$this->oauth_secret = $this->settings['oauth_secret']['value'];
		$this->callbackURL = BASE_URL.DIR_REL.'/index.php/dashboard/skybluesofa/social_post/li/';
	}
	
	public function getSettings() {
		//$this->settings['consumer_key'] = array('title'=>'Consumer Key','value'=>$this->consumerKey);
		//$this->settings['consumer_secret'] = array('title'=>'Consumer Secret','value'=>$this->consumerSecret);
		return $this->settings;
	}
	
	public function getLinkedIn() {
		if ($this->instance) {
			return $this->instance;
		}
		$this->instance = new SocialShareLinkedIn_OAuth($this->api_key, $this->api_secret, $this->oauth_token, $this->oauth_secret);
		if (!is_a($this->instance, "SocialShareLinkedIn_OAuth")) {
			$this->updateCredentials(false);
			$this->instance = false;
		}
		return $this->instance;
	}
	
	public function isRevoked() {
		return false;
		$this->getLinkedIn();
		$response = $this->instance->oAuthRequest('/v1/people/~:(firstName,lastName)', "GET");
		if (strpos($response,'<status>401</status>')!==false) {
			$this->saveSetting('use', '0');
			return true;
		}
		return false;
	}
	
	public function removeCredentials() {
		$this->updateCredentials(null,null);
		$this->getSettingsFromDB();
	}
	
	public function saveCredentials() {
		// LinkedIn connection
		$oauth = new SocialShareLinkedIn_OAuth($this->api_key, $this->api_secret, $_SESSION['li_temp_creds']['oauth_token'], $_SESSION['li_temp_creds']['oauth_token_secret']);
		$credentials = $oauth->getAccessToken($_REQUEST['oauth_verifier']);
		if (isset($credentials['oauth_token']) && isset($credentials['oauth_token_secret'])) {
			$this->updateCredentials($credentials['oauth_token'], $credentials['oauth_token_secret']);
			$returnValue = true;
		} else {
			$returnValue = false;
		}
		unset($_SESSION['li_temp_creds']);
		return $returnValue;		
	}
	
	public function updateCredentials($oauth_token, $oauth_token_secret) {
		$this->saveSetting('oauth_token', $oauth_token);
		$this->saveSetting('oauth_secret', $oauth_token_secret);
		if ($oauth_token && $oauth_token_secret) {
			$connected = 1;
			$this->saveSetting('use', '1');
		} else {
			$connected = 0;
			$this->saveSetting('use', '0');
		}
		$this->saveSetting('connected', $connected);
	}
	
	public function getAuthorizeURL() {
		$linkedinOauth = new SocialShareLinkedIn_OAuth($this->api_key, $this->api_secret);
		$temp = $linkedinOauth->getRequestToken($this->callbackURL);
		$_SESSION['li_temp_creds'] = $temp;
		$url = $linkedinOauth->getAuthorizeURL($temp);
		return $url;
	}
		
	protected function generatePostContents() {
		$message = trim($this->settings['prefix']['value']);
		$xml .= '<share>';
			$xml .= '<content>';
				$xml .= '<title>' . substr($this->pageName,0,200) . '</title>';
				$xml .= '<submitted-url>' . $this->pageUrl . '</submitted-url>';
				if ($this->pageThumbnail) {
					$xml .= '<submitted-image-url>' . $this->pageThumbnail . '</submitted-image-url>';
				}
				$description = trim(substr($this->pageDescription,0,256));
				if ($description) {
					$xml .= '<description>' . $description . '</description>';
				}
			$xml .= '</content>';
			if ($message) {
				$xml .= '<comment>'.$message.'</comment>';
			}
			$xml .= '<visibility><code>anyone</code></visibility>';
		$xml .= '</share>';
		
		return $xml;
	}
	
	protected function postToNetwork($postContents) {
		$success = false;
		$this->getSettings();
		if(is_array($this->settings) && $this->settings['use']['value']) {
			if ($this->settings['allow_promotion']['value']) {
				$this->getLinkedIn();
//				Loader::library('linkedinoauth/linkedinoauth/linkedinoauth', 'skybluesofa_social_share');
				$response = $this->instance->oAuthRequest('v1/people/~/shares', "POST", array(), $postContents, array('Content-Type: text/xml'));
				if (strpos($response,'The token used in the OAuth request is not valid')!==false) {
					$success = false;
					$this->removeCredentials();
				} else {
					$success = true;
				}
			}
		}
		return $success;
	}
	
}
?>