<?php      
class NetworkSocialPost {
	public $settingsGroupName = '';
	
	public $settings=array();
	
	protected $prefix = '';
	protected $facebookPrefix = '';
	protected $pageName='';
	protected $pageUrl='';
	protected $pageShortUrl='';
	protected $pageDescription = '';
	protected $pageThumbnail = '';
	protected $hashTags = '';
	protected $hashTagsGenerated = false;
	
	function __construct() {
		$this->getSettingsFromDB();
	}
	
	public function getSettings() {
		return $this->settings;
	}
	
	public function saveSetting($handle=false, $value=false) {
		$db=Loader::db();
		$sql = "UPDATE btSkybluesofaSocialPostSettings SET VALUE=? WHERE group_name=? AND handle=?";
		$values = array($value, $this->settingsGroupName, $handle);
		$db->execute($sql, $values);
		$this->settings[$handle] = $value;
	}
	
	public function postOnPagePublish($cObj) {
		$cObj = $this->getRealPageObject($cObj);
		if (!$this->isComposerPage($cObj) && ($cObj->cvID == 2)) {
			return;
		}
		$this->generatePageInfo($cObj);
		if (isset($this->settings['send_post']) && $this->settings['send_post']['value']) {
			$this->postToNetwork($this->generatePostContents());
		}
	}
	
	public function promotePage($cID, $prefix=false, $useHashTags=true) {
		$this->generatePageInfo($cID);
		if ($prefix!==false) {
		    $this->settings['prefix']['value'] = trim($prefix);
		    $this->prefix = trim($prefix);
		}
		if (!$useHashTags) $this->hashTags = '';
		return $this->postToNetwork($this->generatePostContents()); 
	}
	
	protected function postToNetwork() {}
	protected function generatePostContents() {}
	
	protected function getSettingsFromDB() {
		$db = Loader::db();
		$sql = "SELECT * FROM btSkybluesofaSocialPostSettings WHERE group_name='".$this->settingsGroupName."' ORDER BY handle";
		@$rs = $db->Execute($sql);
		if (is_object($rs)) {
			while($row = $rs->FetchRow()) {
				$this->settings[$row['handle']]=array('title'=>$row['title'],'value'=>$row['value']);
			}
		}
		$this->getSettings();
	}
	
	protected function getRealPageObject($cObj) {
		if (is_numeric($cObj)) {
			$cObj = Page::getByID($cObj);
		}
		return $cObj;
	}
	
	protected function isComposerPage($cObj) {
		$cObj = $this->getRealPageObject($cObj);
		$ct = CollectionType::getByID($cObj->getCollectionTypeID());
		if (!$ct->isCollectionTypeIncludedInComposer()) {
			return false;
		}
		return true;	
	}
	
	protected function generatePageInfo($cObj) {
		$cObj = $this->getRealPageObject($cObj);
		$nh = Loader::helper('navigation');
		$uh = Loader::helper('url');
		$this->prefix = $this->getPrefix($cObj);
		$this->pageName = $cObj->getCollectionName();
		$this->pageUrl = $nh->getCollectionURL($cObj);
		$this->pageShortUrl = $uh->shortenURL($this->pageUrl);
		$this->pageDescription = $cObj->getCollectionDescription();
		$this->pageThumbnail = $this->getThumbnail($cObj);
		$this->hashTags = $this->getHashTags($cObj);
	}
	
	protected function getPrefix($cObj) {
		$ctID = $cObj->ctID;
		$defaultIndex = 0;
		$prefixes = json_decode($this->settings['prefix']['value']);
		if (isset($prefixes->$ctID)) {
			return $prefixes->$ctID;
		} elseif (isset($prefixes->$defaultIndex)) {
			return $prefixes->$defaultIndex;
		} else {
			return '';
		}
	}
	
	protected function getThumbnail($cObj) {
		$cObj = $this->getRealPageObject($cObj);
		Loader::model('attribute/categories/collection');
		$image_attributes = array('feature_image','page_thumbnail','thumbnail','article_image');
		foreach ($image_attributes as $image_attribute) {
			$image = $cObj->getAttribute($image_attribute);
			if (!empty($image)) {
				break;
			}
		}
		if ($image) {
			return BASE_URL.$image->getRelativePath();
		}
		return null;
	}
	
	protected function getHashTags($cObj) {
		$cObj = $this->getRealPageObject($cObj);
		$ht = array();
		Loader::model('attribute/categories/collection');
		$cak = CollectionAttributeKey::getByHandle('tags');
		$cav = $cObj->getCollectionAttributeValue($cak);
		if (is_object($cav)) {
			foreach ($cav->getOptions() as $opt) {
				$val = trim($opt->value);
				if ($val!='') {
					$ht[] = '#'.str_replace(' ','',ucwords($val));
				}
			}
		}
		return implode(' ', $ht);
	}
}
?>