<?php      
Loader::library('twitteroauth/twitteroauth','skybluesofa_social_share');
Loader::model('network_social_post','skybluesofa_social_share');

class TwitterSocialPost extends NetworkSocialPost {
	public $settingsGroupName = 'twitter';
	
	private $requestTokenUrl='https://api.twitter.com/oauth/request_token';
	private $accessTokenUrl='https://api.twitter.com/oauth/access_token';
	private $authorizeUrl='https://api.twitter.com/oauth/authorize';
	private $verifyUrl='https://api.twitter.com/1.1/account/verify_credentials.json';
	
	function __construct() {
		parent::__construct();
		
		$this->consumer_key='Wh9sA14coEviOc1Kixciw';
		$this->consumer_secret='JemoytDFrWRKSUmK2kWzKmVKKByG3ouHJmy6HBMYnOE';
		//$this->consumer_key = $this->settings['consumer_key']['value'];
		//$this->consumer_secret = $this->settings['consumer_secret']['value'];
		$this->oauth_token = $this->settings['oauth_token']['value'];
		$this->oauth_secret = $this->settings['oauth_token_secret']['value'];
		$this->callbackURL = BASE_URL.DIR_REL.'/index.php/dashboard/skybluesofa/social_post/tw/';
	}
	
	public function getSettings() {
		$this->settings['consumer_key'] = array('title'=>'Consumer Key','value'=>$this->consumerKey);
		$this->settings['consumer_secret'] = array('title'=>'Consumer Secret','value'=>$this->consumerSecret);
		return $this->settings;
	}
	
	public function getTwitter() {
		if ($this->instance) {
			return $this->instance;
		}
		$this->instance = new SocialShareTwitter_OAuth($this->consumer_key, $this->consumer_secret, $this->oauth_token, $this->oauth_secret);
		if (!is_a($this->instance, "SocialShareTwitter_OAuth")) {
			$this->updateCredentials(false, false);
			$this->instance = false;
		}
		return $this->instance;
	}
		
	public function isRevoked() {
		$this->getTwitter();
		if (method_exists($this->instance, 'get')) {
			$this->instance->get($this->verifyUrl);
			if ($this->instance->http_code!='200') {
				$this->removeCredentials();
				$this->saveSetting('use', '0');
				return true;
			}
		}
		return false;
	}
	
	public function removeCredentials() {
		$this->updateCredentials(null,null);
		$this->getSettingsFromDB();
	}
	
	public function saveCredentials() {
		// Twitter connection
		$oauth_token = $_REQUEST['oauth_token'];
		$oath_verifier = $_REQUEST['oauth_verifier'];
		$oauth = new SocialShareTwitter_OAuth($this->consumer_key, $this->consumer_secret, $_SESSION['tw_temp_creds']['oauth_token'], $_SESSION['tw_temp_creds']['oauth_token_secret']);
		$credentials = $oauth->getAccessToken($_REQUEST['oauth_verifier']);
		if (isset($credentials['oauth_token']) && isset($credentials['oauth_token_secret'])) {
			$this->updateCredentials($credentials['oauth_token'], $credentials['oauth_token_secret']);
			$returnValue = true;
		} else {
			$returnValue = false;
		}
		unset($_SESSION['tw_temp_creds']);
		return $returnValue;		
	}
	
	public function updateCredentials($oauth_token, $oauth_token_secret) {
		$this->saveSetting('oauth_token', $oauth_token);
		$this->saveSetting('oauth_token_secret', $oauth_token_secret);
		if ($oauth_token && $oauth_token_secret) {
			$connected = 1;
			$this->saveSetting('use', '1');
		} else {
			$connected = 0;
			$this->saveSetting('use', '0');
		}
		$this->saveSetting('connected', $connected);
	}
	
	public function getAuthorizeURL() {
		unset($_SESSION['tw_temp_creds']);
		$twitterOauth = new SocialShareTwitter_OAuth($this->consumer_key, $this->consumer_secret);
		$temp = $twitterOauth->getRequestToken($this->callbackURL);
		$_SESSION['tw_temp_creds'] = $temp;
		$url = $twitterOauth->getAuthorizeURL($temp);
		return $url;
	}
		
	protected function generatePostContents() {
		$prefix = trim($this->prefix);
		if (strlen($prefix)) $prefix .= ' ';
		if ($this->hashTags) { $this->hashTags = " ".$this->hashTags; }
		$postContents = false;
		// Create an array of possible tweets, starting with the longest and going to the shortest
		$testTexts = array();
		$testTexts[] = $prefix.$this->pageName.' '.$this->pageUrl.$this->hashTags;
		$testTexts[] = $prefix.$this->pageName.' '.$this->pageShortUrl.$this->hashTags;
		
		if ($this->hashTags) {
			// Remove the hash tags one by one until we dont have any left
			$ht = explode(' ',$this->hashTags);
			$numberHT = count($ht);
			for ($i=1;$i<$numberHT;$i++) {
				array_pop($ht);
				$testTexts[] = $prefix.$this->pageName.' '.$this->pageUrl.' '.implode(' ', $ht);
				$testTexts[] = $prefix.$this->pageName.' '.$this->pageShortUrl.' '.implode(' ', $ht);
			}
		}
		// Create the four shortest ones
		$testTexts[] = $prefix.$this->pageName.' '.$this->pageUrl;
		$testTexts[] = $prefix.$this->pageName.' '.$this->pageShortUrl;
		$testTexts[] = $prefix.$this->pageUrl;
		$testTexts[] = $prefix.$this->pageShortUrl;
		foreach ($testTexts as $testText) {
			if (strlen($testText)<=140) {
				$postContents = $testText;
				break;
			}
		}
		return $postContents;
	}
	
	protected function postToNetwork($postContents) {
		$success = false;
		if(is_array($this->settings) && $this->settings['connected']['value'] && $this->settings['use']['value']) {
			$this->getTwitter();
			$this->instance->post('statuses/update', array('status' => $postContents));
			$success = true;
		}
		return $success;
	}
	
}
?>