<?php          
/*
* Additional Page List Views for c5
*
* @package Page List Views
* @author Dave Rogers <dave@sollos.net>
* @version 2.2
* @copyright Copyright (c) 2011, Dave Rogers
* @license http://www.opensource.org/licenses/mit-license.php MIT License
*/

defined('C5_EXECUTE') or die("Access Denied.");
$uh = Loader::helper('concrete/urls');
$h = Loader::helper('concrete/interface');
$vt = Loader::helper('validation/token');
$db = Loader::db();
$form = Loader::helper('form');
$fh = Loader::helper('file');
$sih = Loader::helper('social_icon', 'skybluesofa_social_share');

$cdh = Loader::helper('concrete/dashboard');
if (method_exists($cdh, 'getDashboardPaneHeaderWrapper')) {
	echo Loader::helper('concrete/dashboard')->getDashboardPaneHeaderWrapper(t('Social Connect Networks'), t('Update the icons used in the Social Connect block.'), false, false);
} else {
	echo '<div style="width: 800px;">';
	echo '<h1><span>'.t('Social Connect Networks').'</span></h1>';
	echo '<div class="ccm-dashboard-inner">';
}
?>
<?php             ?>
<div class="ccm-pane-body">	
	<table cellspacing="0" cellpadding="0" style="width:100%;" class="zebra-striped ccm-results-list table">
		<thead>
			<tr>
				<th rowspan="2">&nbsp;</th>
				<th rowspan="2"><?php               echo t('Name');?></th>
				<th rowspan="2"><?php               echo t('Handle');?></th>
				<th rowspan="2"><?php               echo t('Tooltip');?></th>
				<th colspan="5"><?php               echo t('Icons');?></th>
			</tr>
			<tr>
				<th><?php               echo t('48x48');?></th>
				<th><?php               echo t('32x32');?></th>
				<th><?php               echo t('24x24');?></th>
				<th><?php               echo t('16x16');?></th>
				<th><?php               echo t('Other');?></th>
			</tr>
		</thead>
		<tbody>
		<?php               foreach ($networks as $key=>$network) { ?>
		<tr id="skybluesofa_social_network_row_<?php               echo $network['id'];?>">
			<td><a href="#" class="btn info skybluesofa_social_network_edit">Edit</a></td>
			<td class="<?php               echo !$network['active']||!$network['show_existing']?'red ':'';?>name"><?php               echo $network['name'];?></td>
			<td class="<?php               echo !$network['active']||!$network['show_existing']?'red ':'';?>handle"><?php               echo $network['handle'];?></td>
			<td class="<?php               echo !$network['active']||!$network['show_existing']?'red ':'';?>icontooltip"><?php               echo $network['tooltip'];?></td>
			<?php               $iconSizes = array('48','32','24','16','Custom');?>
			<?php               foreach ($iconSizes as $is) {?>
				<td style="text-align:<?php               echo $is=='Custom'?"":"center";?>;" class="icon_<?php               echo $is;?>"><?php               $url=$sih->getUrl($network['handle'],$is,false,($is=='Custom'?100:$is));if ($url) echo '<img src="'.$url.'" style="width:'.$is.'px;height:'.$is.'px;">'; else echo 'No Image' ?></td>
			<?php               } ?>
		</tr>
		<?php               } ?>
		</tbody>
	</table>
</div>
<div class="ccm-pane-footer">
	<form method="post" id="skybluesofa_social_networks_form" action="<?php               echo $this->url('/dashboard/skybluesofa/social_share', 'social_networks')?>" style="margin:0;">
		<?php               echo $vt->output('social_networks'); ?>
		<input name="section" value="social_networks" type="hidden">
		<input type="button" class="btn ccm-button-v2 primary ccm-button-v2-right" value="Add Social Network" id="add-skybluesofa_social_networks_form" name="add-skybluesofa_social_networks_form">
		<input type="button" class="btn ccm-button-v2 ccm-button-v2-left" value="Bulk Network Edit" id="network-activation-skybluesofa_social_networks_form" name="network-activation-skybluesofa_social_networks_form">
	</form>
</div>
<?php       
if (method_exists($cdh, 'getDashboardPaneHeaderWrapper')) {
	echo Loader::helper('concrete/dashboard')->getDashboardPaneFooterWrapper();
} else {
	echo '</div></div>';
}
?>
<script>
$(function(){
	if ($('.ccm-dashboard-page-container').width()>=940) {
		$('.ccm-dashboard-page-container DIV.span16').css('width','100%');
		$('.ccm-dashboard-page-container').css('width','95%');
	}
});
function bindEdits(){
	$(".skybluesofa_social_network_edit").bind('click',function(){
		var selector=$(this).closest('TR').attr('id');
		var id = selector.replace("skybluesofa_social_network_row_","");
		$.fn.dialog.open({
			width: '400px',
			height: '400px',
			modal: false,
			href: '<?php               echo $uh->getToolsURL('edit_network', 'skybluesofa_social_share');?>?id='+id,
			buttons: {"Save":function(){$(this).dialog("close")}},
			appendButtons: true,
			title: "Modify Network"
		});
		return false;
	});
}
bindEdits();

$("#add-skybluesofa_social_networks_form").bind('click',function(){
	$.fn.dialog.open({
		width: '400px',
		height: '400px',
		modal: false,
		href: '<?php               echo $uh->getToolsURL('edit_network', 'skybluesofa_social_share');?>',
		buttons: {"Save":function(){$(this).dialog("close")}},
		appendButtons: true,
		title: "Add Network"
	});
	return false;
});
$("#network-activation-skybluesofa_social_networks_form").bind('click',function(){
	$.fn.dialog.open({
		width: '600px',
		height: '400px',
		modal: false,
		href: '<?php               echo $uh->getToolsURL('edit_all_networks', 'skybluesofa_social_share');?>',
		buttons: {"Save":function(){$(this).dialog("close")}},
		appendButtons: true,
		title: "Bulk Network Edit"
	});
	return false;
});
</script>
<style>
TD.red { color:red;}
</style>
