<?php              
defined('C5_EXECUTE') or die("Access Denied.");

Loader::helper('file');
$sih = Loader::helper('social_icon', 'skybluesofa_social_share');

$db = Loader::db();

if (isset($_POST['id'])) {
	$id = intval($_POST['id']);
	$name = $_POST['name'];
	$handle = $_POST['handle'];
	$tooltip = $_POST['tooltip'];
	$active = $_POST['active'] ? 1 : 0;
	$show_existing = $_POST['show_existing'] ? 1 : 0;
	$icon_48 = $_POST['icon_48'] ? $_POST['icon_48'] : null;
	$icon_32 = $_POST['icon_32'] ? $_POST['icon_32'] : null;
	$icon_24 = $_POST['icon_24'] ? $_POST['icon_24'] : null;
	$icon_16 = $_POST['icon_16'] ? $_POST['icon_16'] : null;
	$icon_custom = $_POST['icon_Custom'] ? $_POST['icon_Custom'] : null;
	
	if (!$_POST['id']) {
		if (!$name) {
			die(json_encode(array('error'=>'Please enter a name for this network.')));
		}
		$sql = "SELECT * FROM btSkybluesofaSocialNetworks WHERE handle LIKE ?";
		$exists = $db->GetRow($sql, array($handle));
		if (!isset($exists['id'])) {
			$sql = "INSERT INTO btSkybluesofaSocialNetworks (name, handle, tooltip, active, show_existing, icon_48, icon_32, icon_24, icon_16, icon_custom, packaged, connect, share) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";
			$db->execute($sql, array($name, $handle, $tooltip, $active, $show_existing, $icon_48, $icon_32, $icon_24, $icon_16, $icon_custom, 0, 1, 0));
			$icon_48_url = $sih->getUrl($handle, 48, false);
			$icon_32_url = $sih->getUrl($handle, 32, false);
			$icon_24_url = $sih->getUrl($handle, 24, false);
			$icon_16_url = $sih->getUrl($handle, 16, false);
			$icon_custom_url = $sih->getUrl($handle, 'custom', false, 100);
			die(json_encode(array('new'=>1,'id'=>$db->Insert_ID(),'name'=>$name,'handle'=>$handle,'tooltip'=>$tooltip,'active'=>$active,'show_existing'=>$show_existing,'icon_48'=>$icon_48_url?$icon_48_url:false,'icon_32'=>$icon_32_url?$icon_32_url:false,'icon_24'=>$icon_24_url?$icon_24_url:false,'icon_16'=>$icon_16_url?$icon_16_url:false,'icon_custom'=>$icon_custom_url?$icon_custom_url:false)));
		} else {
			die(json_encode(array('error' => "The handle that you've entered already exists. Please enter a different handle.")));
		}
	} else {
		$sql = "UPDATE btSkybluesofaSocialNetworks SET name=?, tooltip=?, active=?, show_existing=?, icon_48=?, icon_32=?, icon_24=?, icon_16=?, icon_custom=? WHERE id=?";
		$db->execute($sql, array($name, $tooltip, $active, $show_existing, $icon_48, $icon_32, $icon_24, $icon_16, $icon_custom, $id));
		$icon_48_url = $sih->getUrl($handle, 48, false);
		$icon_32_url = $sih->getUrl($handle, 32, false);
		$icon_24_url = $sih->getUrl($handle, 24, false);
		$icon_16_url = $sih->getUrl($handle, 16, false);
		$icon_custom_url = $sih->getUrl($handle, 'custom', false, 100);
		die(json_encode(array('new'=>0,'id'=>$id,'name'=>$name,'handle'=>$handle,'tooltip'=>$tooltip,'active'=>$active,'show_existing'=>$show_existing,'icon_48'=>$icon_48_url,'icon_32'=>$icon_32_url,'icon_24'=>$icon_24_url,'icon_16'=>$icon_16_url,'icon_custom'=>$icon_custom_url)));
	}
} else {
	$form = Loader::helper('form');
	$ah = Loader::helper("concrete/asset_library");
	$uh = Loader::helper('concrete/urls');

	$network = $db->GetRow("SELECT * FROM btSkybluesofaSocialNetworks WHERE id=?", array($_GET['id']));
	?>
	<script>
	$(function(){
		$('#skybluesofa_social_share_network_properties_form #name').bind('change',function() {
			var tooltipValue = $('#skybluesofa_social_share_network_properties_form #icontooltip').val();
			if (tooltipValue=='' || tooltipValue=='Connect with me on ') {
				var networkname = $(this).val();
				$('#skybluesofa_social_share_network_properties_form #icontooltip').val('Connect with me on '+networkname);
			}
		});
	});
	function saveNetworkProperties() {
		formdata = {};
		$(':input').each(function(){
			$this= $(this);
			if ($this.attr('type')=='checkbox') {
				if ($this.is(":checked")) {
					formdata[$this.attr('name')] = $this.val();
				}
			} else {
				formdata[$this.attr('name')] = $this.val();
			}
		});
		$.ajax({
			type: "POST",
			data: formdata,
			dataType: 'json',
			url: $('#skybluesofa_social_share_network_properties_form').attr('action'),
			success: function(data){
				if (data.error) {
					alert(data.error);
				} else {
					var id = data.id;
					if (data.new) {
						$('#skybluesofa_social_networks_form TABLE TR:last').after('<tr id="skybluesofa_social_network_row_'+id+'"><td><a href="#" class="btn info skybluesofa_social_network_edit">Edit</a></td><td class="name">'+data.name+'</td><td class="handle">'+data.handle+'</td><td class="icontooltip">'+data.tooltip+'</td><td class="icon_48" style="text-align:center;"></td><td class="icon_32" style="text-align:center;"></td><td class="icon_24" style="text-align:center;"></td><td class="icon_16" style="text-align:center;"></td><td class="icon_Custom"></td></tr>');
						$('.skybluesofa_social_network_edit').unbind('click');
						bindEdits();
					}
					if (data.active && data.show_existing) {
						$('#skybluesofa_social_network_row_'+id+' TD').removeClass('red');
					} else {
						$('#skybluesofa_social_network_row_'+id+' TD').addClass('red');
					}
					$('#skybluesofa_social_network_row_'+id+' TD.name').html(data.name);
					$('#skybluesofa_social_network_row_'+id+' TD.icontooltip').html(data.tooltip);
					$('#skybluesofa_social_network_row_'+id+' TD.icon_48').html(data.icon_48?'<img src="'+data.icon_48+'" style="width:48px;height:48px;">':'No Image');
					$('#skybluesofa_social_network_row_'+id+' TD.icon_32').html(data.icon_32?'<img src="'+data.icon_32+'" style="width:32px;height:32px;">':'No Image');
					$('#skybluesofa_social_network_row_'+id+' TD.icon_24').html(data.icon_24?'<img src="'+data.icon_24+'" style="width:24px;height:24px;">':'No Image');
					$('#skybluesofa_social_network_row_'+id+' TD.icon_16').html(data.icon_16?'<img src="'+data.icon_16+'" style="width:16px;height:16px;">':'No Image');
					$('#skybluesofa_social_network_row_'+id+' TD.icon_Custom').html(data.icon_custom?'<img src="'+data.icon_custom+'">':'No Image');
					jQuery.fn.dialog.closeTop();
				}
			},
			error: function(){
				alert('there was an error');
			}
		});
		return false;
	}
	</script>
	
	<div class="ccm-ui" id="ccm-custom-style-wrapper">
		<form method="POST" id="skybluesofa_social_share_network_properties_form" action="<?php               echo $uh->getToolsURL('edit_network', 'skybluesofa_social_share');?>">
				<input type="hidden" name="id" value="<?php               echo $network['id']; ?>">
				<?php               if (isset($network['handle'])) { ?>
				<input type="hidden" name="handle" value="<?php               echo $network['handle']; ?>">
				<?php               } ?>
				<table border="0" cellspacing="0" cellpadding="0" class="ccm-style-property-table table">
					<tr>
						<td><?php               echo t('Name'); ?></td>
						<td><?php               echo $form->text("name", $network['name']); ?></td>
					</tr>
					<?php               if (!isset($network['handle'])) { ?>
						<tr>
							<td><?php               echo t('Handle'); ?></td>
							<td><?php               echo $form->text("handle", ''); ?></td>
						</tr>
					<?php               } ?>
					<tr>
						<td><?php               echo t('Tooltip'); ?></td>
						<?php               
							$defaultTooltip = 'Connect with me on '.$network['name'];
							if ($network['handle']=='email') {
								$defaultTooltip = 'Connect with me via Email';
							} elseif ($network['handle']=='feed') {
								$defaultTooltip = 'Subscribe to my feed';
							} elseif ($network['handle']=='website') {
								$defaultTooltip = 'Connect with me on my Website';
							}
						?>
						<td><?php               echo $form->text("tooltip", empty($network['tooltip'])?$defaultTooltip:$network['tooltip']); ?></td>
					</tr>
					<tr>
						<td>&nbsp;</td>
						<td><label style="float:none;"><input type="checkbox" name="active" id="active" style="float:left;margin-right:3px;" value="1" <?php           echo ($network['active']||!isset($network['active']))?'checked="checked"':''?>> <?php               echo t('Allow adding to new blocks'); ?></label></td>
					</tr>
					<tr>
						<td>&nbsp;</td>
						<td><label style="float:none;"><input type="checkbox" name="show_existing" id="show_existing" style="float:left;margin-right:3px;" value="1" <?php           echo ($network['show_existing']||!isset($network['show_existing']))?'checked="checked"':''?>> <?php               echo t('Show network in current blocks if exists'); ?></label></td>
					</tr>
				</table>
				<h3>Icon Sizes</h3>
				<table border="0" cellspacing="0" cellpadding="0" class="ccm-style-property-table table table-bordered">
					<?php               if (isset($network['handle']) && $network['packaged']) { ?>
						<tr>
							<th>&nbsp;</th>
							<th><?php               echo t('Original'); ?></th>
							<th><?php               echo t('Selected'); ?></th>
						</tr>
					<?php               } ?>
					<?php               
						$iconSizes = array('48','32','24','16','Custom');
						$defaultExists = false;
						foreach ($iconSizes as $is) {
							if (!$defaultExists) {
								$defaultExists = $sih->defaultExists($network['handle'], strtolower($is));
							}
						}
					?>
					<?php               foreach ($iconSizes as $is) {?>
						<tr>
							<td><?php               echo is_numeric($is)?($is."x".$is):$is;?></td>
							<?php               if ($defaultExists || isset($network['handle']) && ($network['packaged'])) { ?>
								<td><?php               $url=$sih->getUrl(strtolower($network['handle']),$is, true);if ($url) echo '<img src="'.$url.'">'; else echo 'No Image' ?></td>
							<?php               } ?>
							<td><?php              echo $ah->image('icon_'.$is, 'icon_'.$is, t('Choose Icon'), File::getByID($network['icon_'.strtolower($is)]))?></td>
						</tr>
					<?php               } ?>
				</table>
			<div class="dialog-buttons">
				<a href="#" class="btn ccm-button-left cancel" onclick="jQuery.fn.dialog.closeTop();return false;"><?php              echo t('Cancel')?></a>
				<a href="#" onclick="saveNetworkProperties();return false;" class="ccm-button-right accept btn primary"><?php              echo t('Save')?></a>
			</div>
		</form>
	</div>
<?php               } ?>
